#!/bin/sh


# App AnaBlock
#==================================================================================================

# - Obtenha o projeto anablock e instale os arquivos em /anablock




# Nginx
#==================================================================================================


# FQDN do servidor: www.anablock.net.br
# Site: anablock.net.br


# - Gerar certificado auto-assinado para dar boot no nginx ja em https
    # - Pasta dos arquivos:
    mkdir -p /etc/ssl/nginx
    cd       /etc/ssl/nginx

    # - Variaveis
    COUNTRY=BR
    PROVINCE="Minas Gerais"
    CITY="Nova Lima"
    COMPANY="TMSoft Solucoes LTDA"
    ORG_UNIT="TMSoft Solucoes"
    COMMONNAME="anablock.net.br"
    EMAIL=patrickbrandao@gmail.com
    VALIDDAYS=3650
    ARG_SUBJ="/C=$COUNTRY/ST=$PROVINCE/L=$CITY/O=$COMPANY/OU=$ORG_UNIT/CN=$COMMONNAME"

    # - Chave privada e certificado
    openssl req -x509 -nodes -days 3650 -newkey rsa:2048 -subj "$ARG_SUBJ" -keyout /etc/ssl/nginx/anablock.key -out /etc/ssl/nginx/anablock.crt


# - Ativar PHP-FPM para processamento de arquivos .php do nginx
    systemctl enable  php7.4-fpm
    systemctl restart php7.4-fpm


# - configure o nginx para rodar a pasta principal em /anablock/htdocs/



# Certbot letsencrypt
#==================================================================================================

    apt-get -y install certbot


    mkdir -p /var/lib/letsencrypt
    mkdir -p /var/log/letsencrypt

    mkdir -p /var/www/html
    mkdir -p /var/www/html
    mkdir -p /var/www/html/.well-known
    mkdir -p /var/www/html/.well-known/acme-challenge


    # - Argumentos adicionais (repete o agree-tos de proposito)
    EMAIL=epessoa@intranet.br

    CERTBOT_ARG_MODE_S="--standalone -w /var/www/html"
    CERTBOT_ARG_MODE_W="--webroot -w /var/www/html"
    CERTBOT_ARG_EMAIL="--agree-tos -n --expand --email $EMAIL --renew-by-default --reinstall"
    CERTBOT_ARG_EXTRA="--agree-tos"
    CERTBOT_ARG_HOOK="--renew-hook 'service nginx restart'"
    CERTBOT_ARG_DOMAIN="-d anablock.net.br -d www.anablock.net.br -d api.anablock.net.br"


    # Tentar com modo webroot
    eval "/usr/bin/certbot certonly $CERTBOT_ARG_MODE_W $CERTBOT_ARG_EXTRA $CERTBOT_ARG_EMAIL $CERTBOT_ARG_DOMAIN $CERTBOT_ARG_ALIASES $CERTBOT_ARG_HOOK"


    # Caso o ngnix nao esteja rodando, usar o modo certbot como servidor http temporario
    # Tentar com modo standalone
    eval "/usr/bin/certbot certonly $CERTBOT_ARG_MODE_S $CERTBOT_ARG_EXTRA $CERTBOT_ARG_EMAIL $CERTBOT_ARG_DOMAIN $CERTBOT_ARG_ALIASES $CERTBOT_ARG_HOOK"


# Certbot
#---------------------------------------------------------------------------------

    snw="$?"




