#!/bin/sh


# Preparar MariDB para sistema AnaBlock


# Instalar MariaDB (MySQL Server)
    apt-get -y install mariadb-server
    apt-get -y install mariadb-client




# Definir senha de root (padrao inicial: ausente)
	# padrao Patrick:  root / tulipasql
    mysqladmin -u root password tulipasql



# Criar banco anablock, usuario e senha

	# Nome do banco de dados: admin
    mysql -uroot -ptulipasql -e "CREATE DATABASE admin;"

    # Criar usuario anablock
    mysql -uroot -ptulipasql -e "CREATE USER IF NOT EXISTS 'anablock'@'localhost' identified by 'tulipasql';"
    mysql -uroot -ptulipasql -e "GRANT ALL PRIVILEGES ON admin.* TO 'anablock'@'localhost' IDENTIFIED BY 'tulipasql';"
    mysql -uroot -ptulipasql -e "FLUSH PRIVILEGES;"
    mysql -uroot -ptulipasql -e "UNINSTALL PLUGIN validate_password;" 2>/dev/null

    # Criar database anablock
    mysql -uroot -ptulipasql admin < /anablock/schema/mariadb/anablock.txt





# Preencher config do MariaDB [server] tunado e com timezone local
    (
        echo
        echo '[mysqld_safe]'
        echo 'nice = 0'
        echo 'skip_log_error'
        echo 'syslog'
        echo "timezone='America/Sao_Paulo'"
        echo
    ) > /etc/mysql/mariadb.conf.d/50-mysqld_safe.cnf

    (
        echo
        echo '[server]'
        echo
        echo '[mysqld]'
        echo 'user                    = mysql'
        echo 'pid-file                = /run/mysqld/mysqld.pid'
        echo 'basedir                 = /usr'
        echo 'datadir                 = /var/lib/mysql'
        echo 'tmpdir                  = /tmp'
        echo 'lc-messages-dir         = /usr/share/mysql'
        echo 'lc-messages             = en_US'
        echo 'skip-name-resolve'
        echo 'skip-external-locking'
        echo 'bind-address            = 127.0.0.1'
        echo 'bind-address            = 10.255.255.254'
        echo 'expire_logs_days        = 10'
        echo 'character-set-server    = utf8mb4'
        echo 'collation-server        = utf8mb4_general_ci'
        echo
        echo '# Tuning, 4x'
        echo 'key_buffer_size         = 512M'
        echo 'max_allowed_packet      = 1G'
        echo 'thread_stack            = 2048K'
        echo 'thread_cache_size       = 32'
        echo 'max_connections         = 512'
        echo 'table_cache             = 512'
        echo
        echo 'table_open_cache        = 512'
        echo 'sort_buffer_size        = 2M'
        echo 'read_buffer_size        = 2M'
        echo 'read_rnd_buffer_size    = 8M'
        echo 'myisam_sort_buffer_size = 64M'
        echo 'query_cache_size        = 32M'
        echo 'thread_concurrency      = 16'
        echo
        echo '[embedded]'
        echo '[mariadb]'
        echo '[mariadb-10.5]'
        echo
    ) > /etc/mysql/mariadb.conf.d/50-server.cnf



    # Ativar MariaDB no boot
    systemctl enable mariadb


    # Reiniciar MariaDB
    systemctl restart mariadb

# Testar:

	mysql -ptulipasql -uroot -e "SHOW DATABASES;"

	mysql -ptulipasql -uanablock admin -e "SHOW TABLES;"




