<?php

    // Funcoes rapidas
    require('/anablock/lib/phpb.php');
    require('/anablock/lib/http.php');
    require('/anablock/lib/usql.php');
    require('/anablock/lib/libconf.php');
    require('/anablock/lib/vlib.php');
    require('/anablock/lib/ipv4.php');
    require('/anablock/lib/ipv6.php');

    // Obter timestamp corrente
    function _current_timestamp($manual_ts=0){
        static $nowts = 0;
        if($manual_ts) $nowts = $manual_ts;
        if(!$nowts) $nowts = @time();
        return $nowts;
    }

    // Obter palavras da API
    // Tratamento da URI consolidada
    $URI = isset($_SERVER['REQUEST_URI']) ? strtolower($_SERVER['REQUEST_URI']) : '';

    // Separar '?' query-string da URL
    $p = strpos($URI, '?');
    if($p!==false) $URI = substr($URI, 0, $p);

    // Analisar paramtros a frente da URL
    // - limpar bordas
    $URI = trim(str_replace('/api/', '', $URI), '/~');
    // - retirar argumentos extras
    $p = strpos($URI, '?');
    if($p !==false) $URI = substr($URI, 0, $p);

    $URI_PARTS = explode('/', $URI);
    for($i=0; $i < 5; $i++) if(!isset($URI_PARTS[$i])) $URI_PARTS[$i] = '';

    $DEBUG = request_int('debug');

    $SOURCE_IP = server('REMOTE_ADDR');

    // Debug de desenvolvimento
    //if($SOURCE_IP=='191.37.76.221') $DEBUG=1;

    $SECTION = $URI_PARTS[0];
    $ARG1 = $URI_PARTS[1];
    $ARG2 = $URI_PARTS[2];
    $ARG3 = $URI_PARTS[3];


    // Timestamp de referencia
    $NOWTS = _current_timestamp(request_int('timestamp', 0));


    // Formato de saida
    // - text, bind, unbound, adlist, json
    $output_list = array('text', 'bind', 'unbound', 'adlist', 'json');
    $output = request('output', '');
    if($output==''){
        $output = 'text';
        foreach($output_list as $tmp){
            if($ARG1==$tmp) $output=$tmp;
            if($ARG2==$tmp) $output=$tmp;
            if($ARG3==$tmp) $output=$tmp;
        }
    }

    // - mode: redirect, deny, nxdomain
    $mode = request('mode', '');

    // - argumentos do mode redirect
    $cname = request('cname', '');
    $ipv4 = request('ipv4', '');
    $ipv6 = request('ipv6', '');
    $cname_target = request('cname_target', $cname);
    $ipv4_target = request('ipv4_target', $ipv4);
    $ipv6_target = request('ipv6_target', $ipv6);
    $file = request('file', '');

    // default-target na URL da API
    if($ipv4_target==''){
        foreach($URI_PARTS as $k=>$tmp){
            if(ipv4_test($tmp)){
                $ipv4_target = $tmp;
                break;
            }
        }
    }
    if($ipv6_target==''){
        foreach($URI_PARTS as $k=>$tmp){
            if(ipv6_test($tmp)){
                $ipv6_target = $tmp;
                break;
            }
        }
    }


    // Obter IDs das ordens abertas
    function &anablock_live_orders_ids(){
        $nowts = _current_timestamp();

        // Obter IDs das ordens ativas
        $orders =& usql_select("SELECT id, name FROM anablock_order WHERE ts_deleted = 0 AND ts_expire > ".$nowts." ORDER BY id;", 'id');

        // Obter chaves (IDs dos registros)
        $oids = array_keys($orders);

        // Converter em lista separada por virtula
        if(!count($oids)) $oids[] = 1; // improvavel, mas melhor nao permitir

        return $oids;
    }


    // Obter lista de IPs
    // - Lista de bloqueados
    function &anablock_ipv4_block_list(){
        $NOWTS = _current_timestamp();
        // Obter todos os IPs cujo bloqueio vigora
        $sql_block = "SELECT id, prefix FROM anablock_objects_prefix4 WHERE ts_start < ".$NOWTS." AND ts_expire > ".$NOWTS." ORDER BY id;";
        $prefix_list_block    =& usql_select($sql_block, 'prefix');
        return $prefix_list_block;
    }
    // - Lista de desbloqueados
    function &anablock_ipv4_unblock_list(){
        $NOWTS = _current_timestamp();
        // Obter todos os IPs cujo bloqueio expirou
        $sql_unblock = "SELECT id, prefix FROM anablock_objects_prefix4 WHERE ts_expire < ".$NOWTS." ORDER BY id;";
        $prefix_list_unblock =& usql_select($sql_unblock, 'prefix');
        return $prefix_list_unblock;
    }



    //echo $_SERVER['REMOTE_ADDR'];
    // || $_SERVER['REMOTE_ADDR']=='167.250.2.133' || $_SERVER['REMOTE_ADDR']=='191.37.78.226'
    if($DEBUG){

        // Como chegou aqui?
        echo '<pre>';
        echo "\n";
        echo "SOURCE_IP=$SOURCE_IP\n";
        echo "URI=$URI\n";
        echo "SECTION=$SECTION\n";
        echo "output=$output\n";
        echo "mode=$mode\n";
        echo "cname_target=$cname_target\n";
        echo "ipv4_target=$ipv4_target\n";
        echo "ipv6_target=$ipv6_target\n";
        echo "\n";
        echo "URI_PARTS:\n";
        print_r($URI_PARTS);
        print_r($_SERVER);
        echo "\n";
        echo '</pre>';
        //exit();
    }




//------------------------------------------------------------------ tratamento de comandos da API

    // Sessao da API
    switch($SECTION){

        // Versao dos dados no database
        case 'version':
            header("Content-Type: text/plain");
            // Arquivo com timestamp da versao
            $vts_file = '/anablock/htdocs/version.ts';
            $version = (int)@file_get_contents($vts_file);
            echo $version,"\n";
            exit();
            break;

        // MD5 dos dados no database
        case 'md5':
            header("Content-Type: text/plain");
            $md5sigfile = '/anablock/htdocs/logbin.md5';
            $md5sum = trim(@file_get_contents($md5sigfile));
            echo $md5sum,"\n";
            exit();
            break;

        // Lista de dominios
        case 'domain':
        case 'domains':

            // Lista de dominios
            $domains_list = array();

            // Tipo de pedido
            switch($ARG1){
                case 'all':
                    // Obter IDs das ordens ativas
                    $oids =& anablock_live_orders_ids();
                    $oids_args = implode(',', $oids);

                    // Obter todos os dominios das ordens em aberto
                    $sql = "SELECT id, fqdn FROM anablock_objects_domain WHERE order_id IN (".$oids_args.") ORDER BY id;";
                    $domains_list =& usql_select($sql, 'id');
                    break;

                case 'order':
                    $oid = (int)$ARG2;

                    // Obter todos os dominios das ordens em aberto
                    $sql = "SELECT id, fqdn FROM anablock_objects_domain WHERE order_id = ".$oid." ORDER BY id;";
                    $domains_list =& usql_select($sql, 'id');
                    break;
            }

            // Evitar duplicacoes usando o fqdn como chave
            $tmp = array();
            foreach($domains_list as $k=>$reg){
                $fqdn = $reg['fqdn'];
                $tmp[$fqdn] = $reg;
            }
            ksort($tmp);
            $domains_list = $tmp;
            unset($tmp);


            // Enviar
            header("Content-Type: text/plain");

            // Critica do modo redirect: precisa ter cname ou ipv4, ipv6 opcional
            if($mode=='redirect' && $ipv4_target=='' && $cname_target=='') $mode = 'nxdomain';
            if($mode=='' && ($ipv4_target!=''||$ipv6_target!=''||$cname_target!='')) $mode='redirect';

            // Modo de saida
            switch($output){

                //----------------------------------------------------------------------------------------
                case 'nsd':
                    if($file=='') $file = '/etc/nsd/db.anablock';
                    foreach($domains_list as $k=>$reg){
                        $domain = $reg['fqdn'];

                        echo 'zone:'."\n";
                        echo '    name: "'.$domain.'"'."\n";
                        echo '    zonefile: "'.$file.'"'."\n";
                        echo "\n";
                    }
                    break;


                //----------------------------------------------------------------------------------------
                case 'unbound':

                    switch($mode){
                        case 'redirect':
                            foreach($domains_list as $k=>$reg){
                                $domain = $reg['fqdn'];
                                echo 'local-zone: "' . $domain . '" redirect'."\n";
                                if($cname_target!=''){
                                    // Redirecionar com CNAME
                                    echo 'local-data: "'.$domain.' CNAME '.$cname_target.'"'."\n";
                                }else{
                                    // Redirecionar com IPv4 e/ou IPv6
                                    if($ipv4_target!=''){
                                        echo 'local-data: "'.$domain.' A '.$ipv4_target.'"'."\n";
                                    }
                                    if($ipv6_target!=''){
                                        echo 'local-data: "'.$domain.' AAAA '.$ipv6_target.'"'."\n";
                                    }
                                }
                            }
                            break;
                        case 'nxdomain':
                        default:
                            foreach($domains_list as $k=>$reg){
                                $domain = $reg['fqdn'];
                                echo 'local-zone: "'.$domain.'" always_nxdomain'."\n";
                            }
                            break;
                    }
                    break;


                //----------------------------------------------------------------------------------------
                case 'bind':
                case 'bind9':

                    if($file=='') $file = '/etc/bind/db.anablock';
                    foreach($domains_list as $k=>$reg){
                        $domain = $reg['fqdn'];
                        echo 'zone "'.$domain.'" IN {type master;file "'.$file.'";allow-update{none;};};'."\n";
                    }

                    break;


                //----------------------------------------------------------------------------------------
                case 'adlist':
                    $ip4 = $ipv4_target;
                    if($ip4=='') $ip4 = '0.0.0.0';
                    foreach($domains_list as $k=>$reg){
                        echo $ip4,' ',$reg['fqdn'],"\n";
                    }
                    break;

                //----------------------------------------------------------------------------------------
                case 'text':
                case 'txt':
                default:
                    foreach($domains_list as $k=>$reg){
                        echo $reg['fqdn'],"\n";
                    }
                    break;

            }

            exit();
            break;


        // Lista de IPv4
        case 'ip4':
        case 'ipv4':
        case 'prefix4':

            // Lista de prefixos
            $prefix_list = array();



            // Tipo de lista desejada
            $delete = 0;
            $list = array();
            switch($ARG1){
                case 'block':
                    $list =& anablock_ipv4_block_list();
                    $prefix_list = array_keys($list);
                    break;

                case 'unblock':
                    $list =& anablock_ipv4_unblock_list();
                    $prefix_list = array_keys($list);
                    $delete = 1;
                    break;
            }


            // Enviar
            header("Content-Type: text/plain");

            // Parametros especificos
            $nexthop = request('nexthop', '');
            $tag = request_int('tag', 0);
            $metric = request_int('metric', 1);
            $comment = request('comment', '');

            // Formado presente?
            $output_fmt = 0; // text
            if(strpos($URI, 'huawei'   ) || $output == 'huawei'   ) $output_fmt = 1;
            if(strpos($URI, 'cisco'    ) || $output == 'cisco'    ) $output_fmt = 2;
            if(strpos($URI, 'juniper'  ) || $output == 'juniper'  ) $output_fmt = 3;
            if(strpos($URI, 'mikrotik' ) || $output == 'mikrotik' ) $output_fmt = 4;
            if(strpos($URI, 'frr'      ) || $output == 'frr'      ) $output_fmt = 5;

            switch($output_fmt){
                // Huawei
                case 1:
                    foreach($prefix_list as $k=>$pfx){
                        $a = explode('/', $pfx);
                        $addr = $a[0];
                        $padaddr = substr($addr.str_repeat(' ', 16), 0, 16);
                        $bits = (int)$a[1];
                        if($delete){
                            // Remover
                            echo 'no ip route-static ',$padaddr,' ', $bits,"\n";
                        }else{
                            // Inserir
                            //echo 'ip route-static ',$padaddr,' ', $bits,"\n";
                            echo 'ip route-static ',$padaddr,' ',ipv4_bitmask2mask($bits),'  ',($nexthop=='' ? 'NULL0' : $nexthop),($metric ? ' preference '.$metric : '' ),($tag?' tag '.$tag:''),($comment!=''? ' description '.$comment : '' ),"\n";
                        }
                    }
                    break;

                // Cisco
                // ip route 45.0.0.0 255.255.255.255 Null0 1 tag 660
                // name ANABLOCK-IPV4
                case 2:
                    foreach($prefix_list as $k=>$pfx){
                        $a = explode('/', $pfx);
                        $addr = $a[0];
                        $padaddr = substr($addr.str_repeat(' ', 16), 0, 16);
                        $bits = (int)$a[1];
                        if($delete){
                            // Remover
                            echo 'no ip route ',$padaddr,' ',ipv4_bitmask2mask($bits),"\n";
                        }else{
                            // Inserir
                            echo 'ip route ',$padaddr,' ',ipv4_bitmask2mask($bits),'  ',($nexthop=='' ? 'Null0' : $nexthop),($metric ? ' '.$metric : '' ),($tag?' tag '.$tag:''),($comment!=''? ' name '.$comment : '' ),"\n";
                        }
                    }
                    break;

                default:
                    // Texto simples
                    echo implode("\n", $prefix_list),"\n";
            }

            // Debug
            if($DEBUG){
                echo '<pre>';
                echo "NOWTS=$NOWTS\n";
                echo "output_fmt=$output_fmt\n";
                echo "\n";
                echo "prefix_list=\n";
                print_r($prefix_list);
                echo "\n";
                echo '</pre>';
            }


            exit();
            break;
    }



?>