

<div id="manual"></div>

<aside id="featured" class="body">
    <article>
        
        <h1 class="entry-title"><a href="../#howtouse">Manual de uso do AnaBlock</a></h1> 


        <p>
            O AnaBlock &eacute; um catalogo de objetos bloqueados judicialmente. Esse site &eacute; uma c&oacute;pia desse sistema, e voc&ecirc; pode instala-lo na sua pr&oacute;pria infraestrutura (servidor, m&aacute;quina virtual, container...) para manter e atualizar os dados a cada nova ordem judicial, of&iacute;cio ou comunicado enviado pela Anatel ou diretamente a voc&ecirc; pelo judici&aacute;rio.<br>
        </p>

        <ul class="simple">
            
            <li><a class="reference" href="/manual.php#manualp0">Controle de vers&atilde;o e atualiza&ccedil;&otilde;es</a></li>
            <li><a class="reference" href="/manual.php#manualp1">Implementar bloqueios de dom&iacute;nios</a></li>
            <li><a class="reference" href="/manual.php#manualp2">Implementar bloqueios de IPs</a></li>
            <li><a class="reference" href="/manual.php#manualp3">Implementar AnaBlock localmente</a></li>
        </ul>
      
    </article>
</aside>





<!-- ======================================= controle de versao ======================================= -->

<div id="manualp0"></div>
<aside id="featured" class="body">
    <article>
        
        <h1 class="entry-title"><a href="../#manualp0">Controle de vers&atilde;o e atualiza&ccedil;&otilde;es</a></h1> 

          <p>
            O banco de dados do sistema AnaBlock sofre altera&ccedil;&otilde;es com frequencia, essas altera&ccedil;&otilde;es se devem pelos seguintes motivos:<br>

            <ul class="simple">
                <li>Novas ordens de bloqueios</li>
                <li>Revoga&ccedil;&atilde;o de uma ou mais ordens de bloqueio</li>
                <li>Expira&ccedil;&atilde;o do per&iacute;odo de bloqueio de algum objeto (dom&iacute;nio, url, ip, ...)</li>
            </ul>
        </p>

<!-- exemplo 1 -->
        <p>
            Para que os softwares e scripts que se alimentam da base de dados do AnaBlock saibam quando recarregar e atualizar seus bloqueios, os seguintes endpoints podem ser usados:
            <br>
            <br>

            Essa URL retorna o timestamp (Unix Timestamp, segundos desde 1970) da &uacute;ltima altera&ccedil;&atilde;o na base:
            <pre class="codeline">https://api.anablock.net.br/api/version</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
            <pre class="codereturn">1703710766</pre>
            </div>
            <br>

            Essa URL retorna o hash MD5 do banco de dados:
            <pre class="codeline">https://api.anablock.net.br/api/md5</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
            <pre class="codereturn">9c38f51944c7f902972e3d89c08c7cbc</pre>
            </div>

            <br>

            Para consultar os objetos bloqueados em uma data espec&iacute;fica voc&ecirc; pode informar a o timestamp na URL do endpoint, no exemplo abaixo, o timestamp 1693664543 marca a data/hora 2 de setembro de 2023, 14:22:23 (UTC):

            <pre class="codeline">https://api.anablock.net.br/ipv4/block/cisco?timestamp=1693664543</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
            <pre class="codereturn">ip route 38.180.4.183     255.255.255.255  Null0 1 
ip route 45.66.249.95     255.255.255.255  Null0 1 
ip route 54.187.119.217   255.255.255.255  Null0 1 
ip route 54.212.219.202   255.255.255.255  Null0 1 
ip route 91.222.173.6     255.255.255.255  Null0 1 
</pre>
            </div>


        </p>

    </article>
</aside>



<!-- ======================================= bloqueio de dominios ======================================= -->

<div id="manualp1"></div>
<aside id="featured" class="body">
    <article>
        
        <h1 class="entry-title"><a href="../#howtouse">Implementar bloqueios de dom&iacute;nios</a></h1> 

        <br>
        <h2>Bloqueio de dom&iacute;nios</h2>
        <p>
            O bloqueio de dom&iacute;nios no sistema de DNS precisa ser implementado no servidor DNS recursivo usado pelos clientes do provedor de Internet. A API que fornece os dom&iacute;nios a serem bloqueados pode fornecer a lista de v&aacute;rias formas, observe:<br>
        </p>


<!-- exemplo 1 -->
        <p>
            Essa URL retorna a lista de todos os dom&iacute;nios bloqueados, 1 dom&iacute;nio por linha:
            <pre class="codeline">https://api.anablock.net.br/domains/all</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">aovivo.club
aovivo.gratis
aovivo.pro
</pre>
</div>
<br>
        </p>


        <p>
            Formatos de retorno suportados:
            <ul class="simple">
                <li>text (default)</li>
                <li>unbound</li>
                <li>bind9</li>
                <li>adlist</li>
            </ul>
        </p>

        <br>
        <h3>Bloqueio de dom&iacute;nios no Unbound (NLnet Labs)</h2>


        <p>
<!-- exemplo 2 -->
            Essa URL retorna a mesma lista no formado unbound:
            <pre class="codeline">https://api.anablock.net.br/domains/all?output=unbound</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">local-zone: "aovivo.club" always_nxdomain
local-zone: "aovivo.gratis" always_nxdomain
local-zone: "aovivo.pro" always_nxdomain
</pre>
</div>
        </p>

<br>





<!-- exemplo 3 -->
        <p>
            Essa URL retorna a mesma lista no formado unbound, redirecionando para o nome do site da Anatel:
            <pre class="codeline">https://api.anablock.net.br/domains/all?output=unbound&cname=anatel.gov.br</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">local-zone: "aovivo.club" redirect
local-data: "aovivo.club CNAME anatel.gov.br"
local-zone: "aovivo.gratis" redirect
local-data: "aovivo.gratis CNAME anatel.gov.br"
local-zone: "aovivo.pro" redirect
local-data: "aovivo.pro CNAME anatel.gov.br"
</pre>
</div>
        </p>
<br>


<!-- exemplo 4 -->
        <p>
            Essa URL retorna a mesma lista no formado unbound, redirecionando para um IPv4 espec&iacute;fico:
            <pre class="codeline">https://api.anablock.net.br/domains/all?output=unbound&ipv4=10.255.128.2</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">local-zone: "aovivo.club" redirect
local-data: "aovivo.club A 10.255.128.2"
local-zone: "aovivo.gratis" redirect
local-data: "aovivo.gratis A 10.255.128.2"
local-zone: "aovivo.pro" redirect
local-data: "aovivo.pro A 10.255.128.2"
</pre>
</div>
        </p>
<br>


<!-- exemplo 5 -->
        <p>
            Essa URL retorna a mesma lista no formado unbound, redirecionando para um IPv4 e IPv6 espec&iacute;ficos:
            <pre class="codeline">https://api.anablock.net.br/domains/all?output=unbound&ipv4=10.255.128.2&ipv6=2001:db8::1</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">local-zone: "aovivo.club" redirect
local-data: "aovivo.club A 10.255.128.2"
local-data: "aovivo.club AAAA 2001:db8::1"
local-zone: "aovivo.gratis" redirect
local-data: "aovivo.gratis A 10.255.128.2"
local-data: "aovivo.gratis AAAA 2001:db8::1"
local-zone: "aovivo.pro" redirect
local-data: "aovivo.pro A 10.255.128.2"
local-data: "aovivo.pro AAAA 2001:db8::1"
</pre>
</div>
        </p>
<br>


        <p>
            Escolha o tipo de retorno desejado (bloqueio nxdomain, redirecionamento CNAME ou para algum IP espec&iacute;fico) e baixe a configura&ccedil;&atilde;o.<br>
            Exemplo:

<pre class="terminal"><span style="color:#fff">#!/bin/bash

# No terminal (shell, bash, ash, ...) execute:</span>

<span style="color: #0ff">APIURL</span><span style="color: #fff">="https://api.anablock.net.br/domains/all?output=unbound"</span>
<span style="color: #0ff">CONF</span><span style="color: #fff">="/etc/unbound/anablock.conf"</span>

<span style="color:#fff"># Baixando config no formato Unbound:</span>
<span style="color: #ff0">curl</span> -s <span style="color: #0ff">$APIURL</span> -o <span style="color: #0ff">$CONF</span>

<span style="color:#fff"># Conferir se baixou corretamente, unifique em um arquivo temporario:</span>
(
    <span style="color: #ff0">cat</span> <span style="color:#fff">/etc/unbound/unbound.conf</span>;
    <span style="color: #ff0">echo</span> "server:";
    <span style="color: #ff0">cat</span> <span style="color:#fff">/etc/unbound/anablock.conf</span>;
)  > <span style="color:#fff">/tmp/unbound-test.conf</span>

<span style="color:#fff"># Testar:</span>
<span style="color: #ff0">unbound-checkconf</span> /tmp/unbound-test.conf
<span style="color: #ccc">unbound-checkconf: no errors in /tmp/unbound-test.conf</span>

</pre>


        </p>

        <p>
            Note no exemplo acima que o conte&uacute;do do anablock.conf deve estar na sess&atilde;o &quot;server:&quot; do unbound. Voc&ecirc; pode incluir o anablock.conf no unbound.conf da seguinte maneira, no final do arquivo:


<pre class="editor_title"># Arquivo <span class="editor_filename">/etc/unbound/unbound.conf</span>
</pre>
<pre class="editor_body" style="background-color: #039; color: #fff"># (conteudo atual)

server:
    include: /etc/unbound/anablock.conf

</pre>
        <br>
        Ap&oacute;s inserir a configura&ccedil;&atilde;o acima, reinicie o unbound para que entre em vigor os bloqueios.
        <br>


        </p>


        <br>
        <h3>Bloqueio de dom&iacute;nios no Bind9 (ISC)</h2>

<!-- exemplo 6 -->
        <p>
            Essa URL retorna a mesma lista no formado bind9 de declara&ccedil;&atilde;o de zonas (usando zona localhost):
            <pre class="codeline">https://api.anablock.net.br/domains/all?output=bind9&file=/etc/bind/db.local</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">zone "aovivo.club" IN {type master;file "/etc/bind/db.local";allow-update{none;};};
zone "aovivo.gratis" IN {type master;file "/etc/bind/db.local";allow-update{none;};};
zone "aovivo.pro" IN {type master;file "/etc/bind/db.local";allow-update{none;};};
</pre>
</div>
        </p>
<br>



<!-- exemplo 7 -->
        <p>
            Essa URL retorna a mesma lista no formado bind9 de declara&ccedil;&atilde;o de zonas, arquivo espec&iacute;fico:
            <pre class="codeline">https://api.anablock.net.br/domains/all?output=bind9&file=/etc/bind/db.anablock</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">zone "aovivo.club" IN {type master;file "/etc/bind/db.anablock";allow-update{none;};};
zone "aovivo.gratis" IN {type master;file "/etc/bind/db.anablock";allow-update{none;};};
zone "aovivo.pro" IN {type master;file "/etc/bind/db.anablock";allow-update{none;};};
</pre>
<br>
            Exemplo do arquivo da zona:

<pre class="editor_title"># Arquivo <span class="editor_filename">/etc/bind/db.anablock</span> ou <span class="editor_filename">/etc/bind/db.local</span>
</pre>
<pre class="editor_body" style="background-color: #039; color: #fff">$TTL    3600
@   IN  SOA localhost. root.localhost. ( 2023122001 604800 86400 2419200 604800 )
@   IN  NS  localhost.
@   IN  A   127.0.0.1
@   IN  AAAA    ::1
</pre>

</div>
        </p>
<br>



        <p>
            Exemplo de implementa&ccedil;&atilde;o em bind9 (com zonas dos dom&iacute;nios bloqueados):

<pre class="terminal"><span style="color:#fff">#!/bin/bash

# No terminal (shell, bash, ash, ...) execute:</span>

<span style="color: #0ff">APIURL</span><span style="color: #fff">="https://api.anablock.net.br/domains/all?output=bind9&file=/etc/bind/db.local"</span>
<span style="color: #0ff">CONF</span><span style="color: #fff">="/etc/bind/anablock.conf"</span>

<span style="color:#fff"># Baixando config no formato Bind de zonas:</span>
<span style="color: #ff0">curl</span> -s <span style="color: #0ff">$APIURL</span> -o <span style="color: #0ff">$CONF</span>

<span style="color:#fff"># Conferir se baixou corretamente, unifique em um arquivo temporario:</span>
(
    <span style="color: #ff0">cat</span> <span style="color:#fff">/etc/bind/named.conf</span>;
    <span style="color: #ff0">cat</span> <span style="color:#fff">/etc/bind/anablock.conf</span>;
)  > <span style="color:#fff">/tmp/bind-test.conf</span>

<span style="color:#fff"># Testar:</span>
<span style="color: #ff0">named-checkconf</span> /tmp/bind-test.conf; <span style="color: #0ff">RET</span><span style="color: #fff">="$?"</span>
<span style="color: #ff0">echo</span> "Retorno: <span style="color: #0ff">$RET</span>"

<span style="color:#fff"># Retorno zero (0) significa que rodou corretamente, retorno 1 ou maior significa erro</span>

</pre>


        </p>


        <p>
            Se o retorno for sucesso (0), voc&ecirc; ja pode incluir o arquivo de zonas bloqueadas no seu named.conf, no final do arquivo coloque:


<pre class="editor_title"># Arquivo <span class="editor_filename">/etc/bind/named.conf</span>
</pre>
<pre class="editor_body" style="background-color: #039; color: #fff"># (conteudo atual)

include "/etc/bind/anablock.conf";

</pre>
        <br>
        Ap&oacute;s inserir a configura&ccedil;&atilde;o acima, reinicie o unbound para que entre em vigor os bloqueios.
        <br>


        </p>






        <br>
        <h3>Bloqueio de dom&iacute;nios nos sistemas ADLIST (e Mikrotik)</h2>

<!-- exemplo 6 -->
        <p>
            Essa URL retorna a mesma lista no formado ADLIST de declara&ccedil;&atilde;o de entradas redirecionadas:
            <pre class="codeline">https://api.anablock.net.br/domains/all/adlist</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">zone:
0.0.0.0 aovivo.club
0.0.0.0 aovivo.gratis
0.0.0.0 aovivo.pro
</pre>
</div>
        </p>
<br>



<!-- exemplo 7 -->
        <p>
            Para conduzir os bloqueios para um IP espec&iacute;fico:
            <pre class="codeline">https://api.anablock.net.br/domains/all/adlist/10.255.128.2</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">
10.255.128.2 aovivo.club
10.255.128.2 aovivo.gratis
10.255.128.2 aovivo.pro
</pre>
<br>
</div>
        </p>



<!-- exemplo 8 -->
        <p>
            Para configurar o Mikrotik, execute no <b>Terminal</b>:
            <div style="margin-left: 30px; margin-top: 6px;">


<pre class="editor_title"># No Winbox, menu <span class="editor_filename">System - Terminal</span>
</pre>
<pre class="terminal" style="background-color: #000; color: #fff">

/ip/dns/adlist
add url=https://api.anablock.net.br/api/domain/all/adlist ssl-verify=no

/system scheduler
add name=reload_adlist interval=1d on-event="/ip dns adlist reload"

</pre>

<pre class="codereturn">
</pre>
<br>
</div>
        </p>





<br>
</aside>






<!-- ======================================= bloqueio de IPs ======================================= -->

<div id="manualp2"></div>
<aside id="featured" class="body">
    <article>
        
        <h1 class="entry-title"><a href="../#howtouse">Implementar bloqueios de IPs</a></h1> 

        <br>
        <h2>Bloqueio de IPs</h2>
        <p>
            O bloqueio de endere&ccedil;os IPs (IPv4, IPv6) podem ser feitos via firewall ou rotas blackhole. Normalmente as rotas blackholes s&atilde;o mais eficientes e mais simples, por outro lado o bloqueio por firewall pode retornar mensagens ICMP &quot;prohibited&quot; e deixar claro para o suporte t&eacute;cnico que h&aacute; um bloqueio intencional dos endere&ccedil;os.<br>
        </p>


        <p>
            T&eacute;cnicas de bloqueio:
            <ul class="simple">
                <li>Rota est&aacute;tica blackhole</li>
                <li>Rota blackhole guiada por BGP</li>
                <li>ACLs e regras de firewall</li>
            </ul>
        </p>

        <p>
            Bloquear IPs requer uma certeza de que o endere&ccedil;o n&atilde;o seja compartilhado com outros servi&ccedil;os. &Eacute; comum que empresas que oferecem servi&ccedil;os de prote&ccedil;&atilde;o DDoS e anti-BOT (como a CloudFlare por exemplo) sejam usados por aplicativos e servi&ccedil;os considerados ilegais e o bloqueio desse IP retire do ar muitos outros sites, servi&ccedil;os e aplicativos.<br>
            <br>
            Outro problema &eacute; o fim do bloqueio dos IPs. Um IP bloqueado mundialmente desperta a aten&ccedil;&atilde;o do ASN dono do IP, que tende a cancelar o contrato relacionado ao uso do IP por NET-ABUSE. Esse IP n&atilde;o pode ficar bloqueado eternamente, assim, bloquear e desbloquear fazem partes das a&ccedil;&otilde;es administrativas do provedor de Internet.
            <br>
            A API fornecer&aacute; duas listas:<br>
            <ul class="simple">
                <li>IPs desbloqueados: IPs cuja janela de bloqueio expirou e devem ser removidos firewalls/blackholes;</li>
                <li>IPs bloqueados: IPs com bloqueio vigente e devem ser bloqueados.</li>
            </ul>
        </p>
        <br>

<!-- exemplo ip1 -->
        <p>
            Essa URL retorna a lista de IPs desbloqueados:
            <pre class="codeline">https://api.anablock.net.br/ipv4/unblock</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">38.180.4.183/32
45.66.249.95/32
54.187.119.217/32
54.212.219.202/32
91.222.173.6/32
91.222.173.121/32
91.222.173.247/32
149.56.1.32/32
149.56.39.16/32
192.95.40.132/32
</pre>
</div>
        </p>

<br>



<!-- exemplo ip2 -->
        <p>
            Essa URL retorna a lista de IPs bloqueados:
            <pre class="codeline">https://api.anablock.net.br/ipv4/block</pre>
            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">191.252.191.216/32
192.95.60.50/32
192.99.42.7/32
192.99.42.177/32
192.99.154.214/32
</pre>
</div>
        </p>

<br>



        <p>
            Formatos de retorno suportados (argumento "output" na QueryString da API):
            <ul class="simple">
                <li>text (default)</li>
                <li>huawei</li>
                <li>cisco</li>
                <li>juniper</li>
                <li>mikrotik</li>
                <li>frr</li>
            </ul>
        </p>

        <p>
            Argumentos adicionais suportados na QueryString da API:
            <ul class="simple">
                <li><i>tag</i> - Define a TAG de rota est&aacute;tica, permite diferenciar as rotas est&aacute;ticas do AnaBlock das demais rotas est&aacute;ticas no roteador quando verificadas em route-map/route-policy;</li>
                <li><i>metric</i> - Define a m&eacute;trica (dist&acirc;ncia ou custo administrativo) da rota est&aacute;tica na RIB, por padr&atilde;o &eacute; 1;</li>
                <li><i>nexthop</i> - Define a interface de blackhole ou IP do pr&oacute;ximo salto para a rota est&aacute;tica, padr&atilde;o Null</li>
            </ul>
        </p>


<!-- exemplo ip2 -->
        <p>
            Use "block" para obter IPs a bloquear (adicionar), e "unblock" para obter IPs a desbloquear (remover), ou "both" para obter o manifesto de comandos para sincronizar com a realidade (deletar os IPs que sairam de vigencia e adicionar os vigentes).<br><br>

            Bloqueio:
            <pre class="codeline">https://api.anablock.net.br/ipv4/block/cisco</pre>

            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">ip route 38.180.4.183     255.255.255.255  Null0 1
ip route 45.66.249.95     255.255.255.255  Null0 1
ip route 54.187.119.217   255.255.255.255  Null0 1
ip route 54.212.219.202   255.255.255.255  Null0 1
ip route 91.222.173.6     255.255.255.255  Null0 1
</pre>
</div>
        </p>

            Bloqueio com detalhes na rota:
            <pre class="codeline">https://api.anablock.net.br/ipv4/block/cisco?metric=10&tag=660&comment=AnaBlock-IPv4</pre>

            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">ip route 38.180.4.183     255.255.255.255  Null0 10 tag 660 name AnaBlock-IPv4
ip route 45.66.249.95     255.255.255.255  Null0 10 tag 660 name AnaBlock-IPv4
ip route 54.187.119.217   255.255.255.255  Null0 10 tag 660 name AnaBlock-IPv4
ip route 54.212.219.202   255.255.255.255  Null0 10 tag 660 name AnaBlock-IPv4
ip route 91.222.173.6     255.255.255.255  Null0 10 tag 660 name AnaBlock-IPv4
</pre>
</div>
        </p>


            <p>
            Desbloqueio:
            <pre class="codeline">https://api.anablock.net.br/ipv4/unblock/cisco</pre>

            <div style="margin-left: 30px; margin-top: 6px;">
            Exemplo de retorno:
<pre class="codereturn">no ip route 38.180.4.183     255.255.255.255
no ip route 45.66.249.95     255.255.255.255
no ip route 54.187.119.217   255.255.255.255
no ip route 54.212.219.202   255.255.255.255
no ip route 91.222.173.6     255.255.255.255
</pre>
</div>

</p>



    </article>
</aside>






