<?php

    // Funcoes rapidas
    require('/anablock/lib/phpb.php');
    require('/anablock/lib/http.php');
    require('/anablock/lib/usql.php');
    require('/anablock/lib/libconf.php');
    require('/anablock/lib/vlib.php');

    $oid = request_int('oid');
    $fid = request_int('fid');

    // Arquivos publicos
    $public_files = array(
        'order.conf',
        'domains.txt',
        'urls.txt',
        'ipv4.txt',
        'ipv6.txt',
        'asn.txt'
    );

    // Se informado, prourar a ordem
    $_def_register = array(
        'id' => 0,
        'name' => '',
        'comment' => '',
        'otype' => 0,
        'confidential' => 0,

        'ts_created' => 0,
        'ts_changed' => 0,
        'ts_start' => 0,
        'ts_expire' => 0,
        'ts_deleted' => 0,

        'uid_created' => 0,
        'uid_changed' => 0,
        'uid_deleted' => 0
    );
    $order = usql_rid('anablock_order', $oid, 'id', $_def_register);

    // Retornar content-type pela extensao do arquivo
    function http_ext_to_content_type($ext){
    	switch($ext){
    		case 'doc':  $r = "application/msword"; break;
    		case 'pdf':  $r = "application/pdf"; break;
    		case 'txt':  $r = "text/plain; charset=utf-8"; break;
    		case 'conf':  $r = "text/plain; charset=utf-8"; break;
    		case 'xlsx': $r = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"; break;
    		case 'xltx': $r = "application/vnd.openxmlformats-officedocument.spreadsheetml.template"; break;
    		case 'docx': $r = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"; break;
    		default:
    			$r = 'application/octet-stream';
    	}
    	return $r;
    }

    // Se encontrou, exibir
    if($order['found']){

        // Obter arquivos
        $odir = '/anablock/orders/'.$oid;
        $files = &_dir_files($odir, '');

        // Confidencial, so permitir arquivos nossos
        if($order['confidential']){
            foreach($files as $k=>$v){
                $fname = basename($v);
                // Remover arquivos nao permitidos
                if(!in_array($fname, $public_files)){
                    unset($files[$k]);
                }
            }
        }

        // Verificar se o fid (id do arquivo requerido) esta no array
        if(isset($files[$fid]) && is_file($files[$fid])){
        	$fpath = $files[$fid];
        	$fname = basename($fpath);
        	$ext = strtolower(file_extension($fname));
        	$size = filesize($fpath);
        	$ctype = http_ext_to_content_type($ext);
        	// $md5sum = md5sum($fpath);
        	// header('X-MD5SUM: '.$md5sum);
        	header('X-Content-Type: '.$ctype);
        	header('X-Content-Length: '.$size);
        	header('X-Fpath: '.$fpath);
			header('Content-Type: '.$ctype);
			header('Expires: 0');
			header('Cache-Control: must-revalidate');
			header('Content-Length: '.$size);
			readfile($fpath);
        	//echo "fpath=[$fpath] fname=[$fname] ext=[$ext] size=[$size] ctype=[$ctype]\n";

        }else{
        	echo "File not found";
        }
    }

?>


