<?php

	// Enviar cabecalhos padrao em todas as respostas
	// Aceitar como argumento opcional o codigo
	// HTTP a ser enviado na resposta

	// httpv: 10 = 1.0
	// httpv: 11 = 1.1
	function http_header($http_code=0, $httpv=11, $inc_vendor=1, $inc_nocache=1){
		// HTTP padrao: 1.1
		$http = 'HTTP/1.1';
		if($httpv===10) $http = 'HTTP/1.0';

		// Status
		switch($http_code){
			case 100: header($http . " ".$http_code." Continue\n"); break; 
			case 101: header($http . " ".$http_code." Switching Protocols\n"); break; 

			case 200: header($http . " ".$http_code." OK\n"); break; 
			case 201: header($http . " ".$http_code." Created\n"); break; 
			case 202: header($http . " ".$http_code." Accepted\n"); break; 
			case 203: header($http . " ".$http_code." Non-Authoritative Information\n"); break; 
			case 204: header($http . " ".$http_code." No Content\n"); break; 
			case 205: header($http . " ".$http_code." Reset Content\n"); break; 

			case 300: header($http . " ".$http_code." Multiple Choices\n"); break; 
			case 301: header($http . " ".$http_code." Moved Permanently\n"); break; 
			case 302: header($http . " ".$http_code." " . ($httpv===10? 'Moved Temporarily' : 'Found') . "\n"); break;
			case 303: header($http . " ".$http_code." See Other\n"); break; 
			case 304: header($http . " ".$http_code." Not Modified\n"); break; 
			case 305: header($http . " ".$http_code." Use Proxy\n"); break; 
			case 306: header($http . " ".$http_code." Unused\n"); break; 
			case 307: header($http . " ".$http_code." Temporary Redirect\n"); break; 

			case 400: header($http . " ".$http_code." Bad Request\n"); break; 
			case 401: header($http . " ".$http_code." Unused\n"); break; 
			case 402: header($http . " ".$http_code." Payment Required\n"); break; 
			case 403: header($http . " ".$http_code." Forbidden\n"); break; 
			case 404: header($http . " ".$http_code." Not Found\n"); break; 
			case 405: header($http . " ".$http_code." Method Not Allowed\n"); break; 
			case 406: header($http . " ".$http_code." Not Acceptable\n"); break; 
			case 407: header($http . " ".$http_code." Unused\n"); break; 
			case 408: header($http . " ".$http_code." Request Timeout\n"); break; 
			case 409: header($http . " ".$http_code." Conflict\n"); break; 
			case 410: header($http . " ".$http_code." Gone\n"); break; 

			case 411: header($http . " ".$http_code." Length Required\n"); break; 
			case 412: header($http . " ".$http_code." Unused\n"); break; 
			case 413: header($http . " ".$http_code." Payload Too Large\n"); break; 
			case 414: header($http . " ".$http_code." URI Too Long\n"); break; 
			case 415: header($http . " ".$http_code." Unsupported Media Type\n"); break; 
			case 416: header($http . " ".$http_code." Unused\n"); break; 
			case 417: header($http . " ".$http_code." Expectation Failed\n"); break; 
			case 426: header($http . " ".$http_code." Upgrade Required\n"); break; 

			case 500: header($http . " ".$http_code." Internal Server Error\n"); break; 
			case 501: header($http . " ".$http_code." Not Implemented\n"); break; 
			case 502: header($http . " ".$http_code." Bad Gateway\n"); break; 
			case 503: header($http . " ".$http_code." Service Unavailable\n"); break; 
			case 504: header($http . " ".$http_code." Gateway Timeout\n"); break; 
			case 505: header($http . " ".$http_code." HTTP Version Not Supported\n"); break; 

			default:
				header($http . " 200 OK\n");
		}
		if($inc_vendor){
			header("Server: Admin4-httpd");
			header("X-Software-Info: admin4-admin-std, Nuva Solucoes\n");
			header("X-Software-Website: http://www.nuva.com.br\n");
			header("X-Software-Author: Patrick Brandao, patrickbrandao@gmail.com\n");
		}
		if($inc_nocache){
			http_nocache_headers();
		}
	}

	// Cabecalhos para evitar cache do navegador/agent
	function http_nocache_headers(){
		header('Cache-Control: no-cache, no-store, private');
		header('Pragma: no-cache');
		//header("Expires: Mon, 17 Feb 1997 12:34:56 GMT");
		header("Expires: Thu, 17 Feb 1983 10:00:00 GMT\n");
	}

	// procurar variavel HTTP, seja GET ou POST
	function &request($vname, $df=''){
		if(is_array($_REQUEST) && array_key_exists($vname, $_REQUEST)){
			$_r = &$_REQUEST[$vname];
		}else{
			$_r = $df;
		}
		return($_r);
	}
	// request com filtro de limpeza
	function &request_eregi($vname, $regex){
		$_r = @eregi_replace($regex, "", request($vname));
		return($_r);
	}

	// obter variaveis de request que estejam presentes
	// num array modelo
	function &request_list($list){
		foreach ($list as $vname=>$stdvle)
			if(is_array($_REQUEST) && array_key_exists($vname, $_REQUEST))
				$list[$vname] = is_int($stdvle) ? (int)$_REQUEST[$vname] : $_REQUEST[$vname];
			//-
		//-
		return $list;
	}

	// procurar variavel HTTP, GET apenas
	function &get($vname, $df=''){
		if(is_array($_GET) && array_key_exists($vname, $_GET)){
			$_r = &$_GET[$vname];
		}else{
			$_r = $df;
		}
		return($_r);
	}
	// procurar variavel HTTP, POST apenas
	function &post($vname, $df=''){
		if(is_array($_POST) && array_key_exists($vname, $_POST)){
			$_r = &$_POST[$vname];
		}else{
			$_r = $df;
		}
		return($_r);
	}

	// retornar todas as variaveis de envio
	function &request_getall(){
		$_r = $_REQUEST;
		return($_r);
	}
	function &post_getall(){ return($_POST); }
	function &get_getall(){ return($_GET); }

	// verificar se a variavel foi enviada
	function &request_isset($vname){
		$_r = false;
		if(array_key_exists($vname, $_REQUEST)) $_r = true;
		return($_r);
	}
	function &post_isset($vname){
		$_r = false;
		if(array_key_exists($vname, $_POST)) $_r = true;
		return($_r);
	}
	function &get_isset($vname){
		$_r = false;
		if(array_key_exists($vname, $_GET)) $_r = true;
		return($_r);
	}

	// util
	function &request_int($vname, $df=0){
		if(is_array($_REQUEST) && array_key_exists($vname, $_REQUEST)){
			$_r = &$_REQUEST[$vname];
		}else{
			$_r = $df;
		}
		$_r = (int)$_r;
		return($_r);
	}

	// procurar variavel do servidor
	function &server($vname, $df=''){
		if(is_array($_SERVER) && array_key_exists($vname, $_SERVER)){
			$_r = &$_SERVER[$vname];
		}else{
			$_r = $df;
		}
		return($_r);
	}

	function &cookie($vname, $df=''){
		if(is_array($_COOKIE) && array_key_exists($vname, $_COOKIE)){
			$_r = &$_COOKIE[$vname];
		}else{
			$_r = $df;
		}
		return($_r);
	}
	function &cookie_int($vname, $df=''){
		$v = (int)cookie($vname, $df);
		return $v;
	}
	function cookie_delete($vname){
		// remover cookie da memorie em execucao
		if(isset($_COOKIE[$vname])) unset($_COOKIE[$vname]);
		// remover cookie do navegador
		setcookie($vname, NULL, -1);
	}


	// lembrar de variavel armazenada na sessao caso omissa no request e salvar na sessao caso presente
	function remember($varname){
		$value=trim(request($varname));
		if($value==''){
			// ausente 
			$value=session($varname);
		}else{
			// presente em request, salvar na sessao para lembrar depois
			$_SESSION[$varname]=$value;
		}
		return $value;
	}

?>