<?php


	// Funcoes para uso de SQL com MariaDB
	// Camada facilitadora entre versoes do PHP e drivers MySQL

	// Obter variavel de ambiente ou usar valor sugerido
	function usql_env($vn, $df=''){
		return isset($_ENV[$vn]) ? (is_numeric($df) ? (int)$_ENV[$vn] : $_ENV[$vn]) : $df;
	}

	// Versao do php
	function usql_phpv(){
		static $v = 0;
		if($v) return $v;
		$v = (int)substr(phpversion(), 0,1);
		return $v;
	}

	// obter microtime (1s dividido por 1 milhao) para calculo de latencia
	function &usql_mctime(){
		$mc = (int)(microtime(1)*1000000);
		return $mc;
	}
	// obter milisegundos (1s dividido por 1 mil) para calculo de latencia
	function &usql_mstime(){
		$ms = (int)(microtime(1)*1000);
		return $ms;
	}


	// Variaveis de acesso padrao
	$USQL_SERVER_ADDR = usql_env('USQL_SERVER_ADDR', 'localhost');
	$USQL_SERVER_PORT = usql_env('USQL_SERVER_PORT', 3306);
	$USQL_SERVER_USER = usql_env('USQL_SERVER_USER', 'anablock');
	$USQL_SERVER_PASS = usql_env('USQL_SERVER_PASS', 'tulipasql');
	$USQL_SERVER_DB   = usql_env('USQL_SERVER_DB',   'admin');
	$USQL_SERVER_LINK = false;



	// conectar SLOT uSQL com banco de dados
	// _dbid=id do slot de banco de dados, force_start=ignorar verificacao inicial, limpar slot e iniciar do zero
	function usql_connect(){
		global $USQL_SERVER_ADDR;
		global $USQL_SERVER_PORT;
		global $USQL_SERVER_USER;
		global $USQL_SERVER_PASS;
		global $USQL_SERVER_DB;
		global $USQL_SERVER_LINK;

		// Obter versao do PHP
		$phpv = usql_phpv();

		// iniciar manutencao de conexao
		$_h = $USQL_SERVER_ADDR == 'localhost' ? $USQL_SERVER_ADDR : $USQL_SERVER_ADDR.':'.$USQL_SERVER_PORT;
		$_u = $USQL_SERVER_USER;
		$_p = $USQL_SERVER_PASS;
		$_dbname = $USQL_SERVER_DB;
		$_ch='utf8';
		$keep_alive = 1;

		// Ja conectou antes
		if($USQL_SERVER_LINK) return;


		// Conectar no MySQL / MariaDB
		// Php 5 (debian bem velho)
		if($phpv < 7){
			// PHP 4 e 5
			if($keep_alive){
				$USQL_SERVER_LINK=mysql_pconnect($_h,$_u,$_p);
			}else{
				$USQL_SERVER_LINK=mysql_connect($_h,$_u,$_p, $USQL_COUNT?true:false);
			}				
		}
		// Php7 (debian 10 e 11)
		if($phpv === 7){
			// PHP 7
			$USQL_SERVER_LINK=mysqli_connect($_h,$_u,$_p, $_dbname);
		}

		// Php8? E agora?
		if($phpv === 8){
			echo "USQL: Fatal, php8 nao programado\n";
			exit();
		}

		// Problemas?
		if(!$USQL_SERVER_LINK){
			// erro na conexao, isso nao é nada bom...
			$_err = "uSQL ".($keep_alive?'p':'').'connect error on server=[' . $_h .'] user=[' . $_u . '] db=[' . $_dbname . ']';
			echo $_err."\n";
			exit();
		}			

		// Pos conexao, ajustes:

		// definir codificacao
		if( $phpv < 7 ){
			mysql_set_charset($_ch, $USQL_SERVER_LINK);
		    mysql_query("SET NAMES '".$_ch."'", $USQL_SERVER_LINK);
			// codificacao no ambiente SQL
			mysql_query('SET character_set_connection='.$_ch, $USQL_SERVER_LINK);
			mysql_query('SET character_set_client='.$_ch, $USQL_SERVER_LINK);
			mysql_query('SET character_set_results='.$_ch, $USQL_SERVER_LINK);
		}
		if( $phpv === 7 ){
			mysqli_set_charset($USQL_SERVER_LINK, $_ch);
			// codificacao no ambiente SQL
			mysqli_query($USQL_SERVER_LINK, 'SET character_set_connection='.$_ch);
			mysqli_query($USQL_SERVER_LINK, 'SET character_set_client='.$_ch);
			mysqli_query($USQL_SERVER_LINK, 'SET character_set_results='.$_ch);
		}

		// tudo OK até agora, selecionar banco de dados, o que é o mais delicado...
		if( ( $phpv < 7) &&  $_dbname!==''){
			$USQL_SERVERS[$_dbid]['db'] = mysql_select_db($_dbname, $USQL_SERVER_LINK);
			if(!$USQL_SERVERS[$_dbid]['db']){

				$er = ''; $en = 0;
				if( $phpv < 7){ $er = mysql_error($USQL_SERVER_LINK); $en = mysql_errno($USQL_SERVER_LINK); }
				if( $phpv === 7){ $er = mysqli_error($USQL_SERVER_LINK); $en = mysqli_errno($USQL_SERVER_LINK); }

				usql_log("Database select problem in ".$_h.';'.$_u.';'.$_dbname." [ka=".$keep_alive." dbi=id=".$_dbid."] error=".$en.':'.$er, 1);
				// Retornar TRUE mesmo falhando ao selecionar o banco de dados, permitir
				// uso de SQLs que nao dependem do banco padrao
				return true;
			}
		}
		return true;
	}

	// executar SQL
	// retorno:
	// false - falha em executar
	// numero - Identificador do recurso
	//
	$USQL_RS = 0;
	$USQL_ERRNO = 0;
	$USQL_ERROR='';
	function &usql_query($_sql){
		global $USQL_RS;
		global $USQL_ERRNO;
		global $USQL_ERROR;
		global $USQL_SERVER_LINK;
		
		// Conectar caso ja nao esteja conectado
		usql_connect();

		// retornar false ou array com referencias do objeto armazenado aqui na camada
		$_r = false;
		if($_sql==''){
			$USQL_ERRNO = 1;
			$USQL_ERROR='SQL empty';
			return $_r;
		}

		// Obter versao do PHP
		$phpv = usql_phpv();

		if( $phpv <   7) $USQL_RS = mysql_query($_sql, $USQL_SERVER_LINK);
		if( $phpv === 7) $USQL_RS = mysqli_query($USQL_SERVER_LINK, $_sql);

		// analisar problemas
		if(!$USQL_RS){

			$er = ''; $en = 0;
			if( $phpv < 7){ $er = mysql_error($USQL_SERVER_LINK); $en = mysql_errno($USQL_SERVER_LINK); }
			if( $phpv === 7){ $er = mysqli_error($USQL_SERVER_LINK); $en = mysqli_errno($USQL_SERVER_LINK); }

			// problema ao executar
			$USQL_ERRNO = $en;
			$USQL_ERROR='query err=['.$en.'/'. $er .'] uSQL='.$_sql;
			$r = false;
			return $r;
		}

		// executado com sucesso!
		$USQL_ERRNO = 0;
		$USQL_ERROR=false;

		// retornar ID do resource uSQL
		return $USQL_RS;
	}

	// obter quantidade de registros de um resource
	function usql_count($_rsid){
		global $USQL_RS;
		$phpv = usql_phpv();
		$c = 0;
		if( $phpv <   7) $c = mysql_num_rows($USQL_RS);
		if( $phpv === 7) $c = mysqli_num_rows($USQL_RS);
		return $c;		
	}

	// liberar recursos
	function usql_free(&$_rsid){
		global $USQL_RS;
		if($USQL_RS){
			// Obter versao do PHP
			$phpv = usql_phpv();
			if( $phpv <   7) @mysql_free_result($USQL_RS);
			if( $phpv === 7) @mysqli_free_result($USQL_RS);
			return true;
		}
		return false;
	}


	// recuperar registro do resultado tipo lista (select, show, describe)
	function &usql_fetch(&$_rsid, $_clean=true){
		global $USQL_RS;

		// Obter versao do PHP
		$phpv = usql_phpv();

		$_reg = false;

		// obter registro
		if( $phpv <   7) $_reg = mysql_fetch_array($USQL_RS);
		if( $phpv === 7) $_reg = mysqli_fetch_array($USQL_RS);
		if(!is_array($_reg)){return $_reg;}

		// limpar registro
		if($_clean)
			foreach($_reg as $_k=>$_v)
				if(is_int($_k)) unset($_reg[$_k]);
			//-
		//-
		if(!count($_reg)){$_reg=false;return $_reg;}
		return $_reg;
	}


	// retornar array resultante de todos os registros de uma select
	function &usql_select($sql, $idx=''){
		$list = array();
		$rs = usql_query($sql);
		$c = 1;
		if($rs && usql_count($rs)){
			while($reg =& usql_fetch($rs)){
				if($idx!=''){
					$k = $reg[$idx];
				}else{
					$k = $c;
				}
				$c++;
				$list[$k] = $reg;
			}
		}
		usql_free($rs);
		return $list;
	}


	// Retornar array resultante de todos os registros de uma select formatando o tipo
	// das colunas com basse no array de registro stdreg
	function &usql_select_format($sql, $idx, $stdreg_format){
		$list = array();
		$rs = usql_query($sql);
		if(!is_array($stdreg_format)) $stdreg_format = array();
		if($rs && usql_count($rs)){
			$c = 0;
			while($reg =& usql_fetch($rs)){

				// Nova linha, registro padrao
				$xreg = $stdreg_format;

				// formatar tipo nas colunas do registro
				foreach($stdreg_format as $varname=>$def_vle){

					// Valor padrao se encontra no registro da tabela
					if(isset($reg[$varname])){

						// Valor da coluna do resultado SQL
						$vle = $reg[$varname];

						// Cast de tipo
						if(is_int($def_vle)){
							 $xreg[$varname] = (int)$vle;

						}elseif(is_float($def_vle)){
							$xreg[$varname] = (float)$vle;

						}else{
							// string
							$xreg[$varname] = $vle;
						}

					}else{
						// Usar valor padrao na coluna ausente
						$xreg[$varname] = $def_vle;
					}

				}
				$c++;
				// chave
				if(isset($xreg[$idx])){
					$key = $xreg[$idx];
				}else{
					$key = $c;
				}
				
				// catalogar
				$list[$key] = $xreg;
			}
		}
		usql_free($rs);
		return $list;
	}



	// retornar registro unico de um resultado (normalmente com limit 1 ou busca por id)
	function &usql_get($sql, $_df = false){
		$ret = array('found' => 0);
		$rs = usql_query($sql);
		if($rs && usql_count($rs)){
			$reg =& usql_fetch($rs);
			foreach($reg as $k=>$v)$ret[$k] = $v;
			$ret['found'] = 1;
		}
		// padronizar
		if(is_array($_df)){
			if($ret['found']){
				// ajuste de tipo
				foreach($_df as $k=>$v)
					if(is_int($v))
						$ret[$k] = (int)$ret[$k];
					//-
				//-
			}else{
				// retorno padrao
				$ret = $_df;
				$ret['found'] = 0;
			}
		}
		usql_free($rs);
		return $ret;
	}

	// retornar registro unico baseado em uma coluna de indice unico
	function &usql_rid($_table, $_id, $_col='id', $_df = false){
		$ret = array('found' => 0);
		if(is_array($_df)){
			$ret = $_df;
			$ret['found'] = 0;
		}

		$rs = usql_query("SELECT * FROM ".$_table." WHERE ".$_col." = ".(is_numeric($_id)?$_id:"'".addslashes($_id)."'")." LIMIT 1");
		if($rs && usql_count($rs)){
			$reg =& usql_fetch($rs);

			// colocar colunas da registro no retorno
			foreach($reg as $k=>$v) $ret[$k] = $v;

			// marcar como encontrado
			$ret['found'] = 1;
		}

		// padronizar com o resultado esperado no default $_df
		if(is_array($_df)){
			if($ret['found']){
				// ajuste de tipo, retornar apenas
				// colunas do array prototipo
				$reg = $df;
				foreach($_df as $k=>$v){
					if(is_int($v)) {
						// Tipo inteiro
						$reg[$k] = (int)$ret[$k];
					}else{
						// Tipo string
						$reg[$k] = $ret[$k];
					}
				}
				$reg['found'] = 1;
			}else{
				// retorno padrao
				$ret = $_df;
				$ret['found'] = 0;
			}
		}
		usql_free($rs);
		return $ret;
	}

	// listar uma tabela inteira
	function &usql_list($table, $idx=false, $cols=false){
		$list = array();
		if(substr($table, 0,1)!='@') $table = "@{".$table."}";
		
		// colunas
		if(is_array($cols)) $cols = implode(',', $cols);
		if(!is_string($cols) || $cols=='') $cols = '*';
		
		$sql = "SELECT ".$cols." FROM ".$table."";
		if($idx) $sql .= " ORDER BY ".$idx;
		$rs = usql_query($sql);
		$c = 1;
		if($rs){
			if(usql_count($rs)){
				while($reg =& usql_fetch($rs)){
					$k = $c++;
					if($idx) $k = $reg[$idx];
					$list[$k] = $reg;
				}
			}
		}
		usql_free($rs);
		return $list;
	}


	// Linhas afetadas
	function usql_affected_rows($_rsid){
		$c = 0;
		//if($_rsid) $c = $USQL_RS[$_rsid]['count'];
		return $c;
	}

	// Converter array em UPDATE sem encapsulamento de valor
	// Retorna update sem where! Fique esperto.
	function usql_reg2u($_reg, $_table){
		$_sql = 'UPDATE ' . $_table . ' SET ';

		// Array de atribuicoes
		$_sets = array();
		foreach($_reg as $col=>$vle){
			if(is_int($vle)){
				$_sets[] = $col . '=' . $vle;
			}else{
				$_sets[] = $col . "='" . addslashes($vle) . "'";
			}
		}
		// Juntar array de atribuicoes separando por virgula
		$_sql .= implode(', ', $_sets);
		return $_sql;
	}

	// Atualizar registro unico, retornar se a linha foi afetada
	// Argumentos:
	// _table : nome da tabela
	// _reg   : array do registro
	// _id    : id do registro
	// _idkey : nome da coluna de ID, padrao 'id'
	function &usql_update_register($_table, $_reg, $_id, $_idkey='id'){
		$ret = array(
			'rs' => 0,
			'table' => $_table,
			'reg' => $_reg,
			'id' => $_id,
			'idkey' => $_idkey,
			'sql' => '',
			'affected' => 0,
			'errno' => 0,
			'error' => ''
		);

		// Coluna de chave primaria nao pode estar no array
		if(isset($_reg[$_idkey])) unset($_reg[$_idkey]);

		$_sql =& usql_reg2u($_reg, $_table);
		$_sql .= ' WHERE '.$_idkey.' = '.$_id . ' LIMIT 1';
		$ret['sql'] = $_sql;

		$ret['rs'] = usql_query($_sql);
		if($ret['rs']){
			$ret['affected'] = usql_affected_rows($ret['rs']);
		}else{
			// deu erro
			$ret['errno'] = usql_errno();
			$ret['error'] = usql_error();
		}

		return $ret;
	}

	// converter array em INSERT encapsulando strings
	function usql_a2i($_reg, $_table){
		// $_kv = array_values($_reg);
		$adds = array();
		foreach($_reg as $col=>$vle){
			if(is_int($vle)){
				$adds[$col] = $vle;
			}else{
				$adds[$col] = '"' . addslashes($vle) . '"';
			}
		}
		//-
		$_sql = 'INSERT INTO '.$_table.' ('.implode(',', array_keys($adds)).') VALUES ('.implode(',', array_values($adds)).');';
		return $_sql;
	}

	// converter array em INSERT sem encapsulamento de valor
	function &usql_reg2i($_reg, $_table){
		$_sql = 'INSERT INTO '.$_table.' ('.implode(',', array_keys($_reg)).') VALUES ('.implode(',', array_values($_reg)).');';
		return $_sql;
	}

	// inserir registro usando usql_a2i
	// retorna ID do novo registro
	function &usql_insert($_table, $_reg){
		$_sql = & usql_a2i($_reg, $_table);
		$_rsi = & usql_query($_sql);
		return $_rsi;
	}

	// inserir registro usando usql_reg2i
	// retorna ID do novo registro
	function &usql_insert_reg($_table, $_reg){
		$_sql = & usql_reg2i($_reg, $_table);
		$_rsi = & usql_query($_sql);
		return $_rsi;
	}

	// obter id de registro inserido
	// function &usql_insert_id(&$_rsid){
	// 	global $USQL_RS;
	// 	$_r = (
	// 		isset($USQL_RS[$_rsid]) &&
	// 		isset($USQL_RS[$_rsid]['iid'])
	// 	) ?
	// 		$USQL_RS[$_rsid]['iid']
	// 	:
	// 		0;
	// 	return $_r;
	// }

	// Remover pelo id
	function usql_delete_row($_table, $_id, $_idkey='id'){
		// Perigoso demais pra fazer
		if($_id=='' || $_idkey=='') return 0;

		// Montar SQL de delete
		$_sql_del = "DELETE FROM ".$_table." WHERE ";
		if(is_numeric($_id)){
			$_sql_del .= $_idkey . ' = '.$_id;
		}else{
			$_sql_del .= $_idkey."='".addslashes($_id)."'";
		}
		// Executar
		$_rsdel = & usql_query($_sql_del);
		if($_rsdel){
			// Retornar linhas afetadas
			return usql_affected_rows($_rsdel);
		}
		return 0;
	}

	// gerar campo de set do update baseado em array com colunas e valores
	// fields devera ser um array simples com colunas que serao usadas
	function &usql_update_getsetpart($_reg, $fields=false){
		$_a = array();
		
		// filtro de campos
		if(is_array($fields) && count($fields)){
			$_b = array();
			foreach($fields as $field) $_b[$field] = $_a[$field];
			$_a = $_b;
		}
		
		if(is_array($_reg))
			foreach($_reg as $k=>$v)
				$_a[] = $k."='".addslashes($v)."'";
			//-
		//-
		$_setpart = implode(",", $_a);
		return $_setpart;
	}





?>