<?php


	// Funcoes para validacao de dados

 	// Verificar se é um endereço IP sintaticamente correto
	function vlib_ipv4($_ip){
		$_ip = trim($_ip);
		if(filter_var($_ip, FILTER_VALIDATE_IP)){
			return true;
		}else{
			return false;
		}
	}


	// verificar se é um endereço IPv6 sintaticamente correto
	function vlib_ipv6($_ip6){
		$_ip6 = trim($_ip6);  
		if(filter_var($_ip6, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)){
			return true;
		}else{
			return false;
		}
	}



	// verificar se uma url é sintaticamente correta
	function vlib_url($url){
		$checklist = array();
		//$checklist[] = '[a-z0-9]+\\.(ad|ae|aero|af|ag|ai|al|am|an|ao|aq|ar|arpa|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|biz|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|com|coop|cr|cs|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|in|info|int|io|iq|ir|is|it|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|museum|mv|mw|mx|my|mz|na|name|nc|ne|net|nf|ng|ni|nl|no|np|nr|nt|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|pro|ps|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)/?$';
		$checklist[] = '^(http[s]'.'?:/'.'/|ftp:/'.'/)?([a-z0-9]+\\.)?';
		$checklist[] = '[a-z0-9]+\\.[a-z0-9]+';
		$errlist = array('@', '\\.\\.', '^[_.-]', '[_.-]$', '^[a-z0-9]+$');
		foreach($errlist as $k=>$v) if(@eregi($v, $url)) return(false);
		foreach($checklist as $k=>$v) if(!@eregi($v, $url)) return(false);
		return(true);
	}


	// verificar se uma FQDN é sintaticamente correta
	function vlib_fqdn($fqdn){
		if($fqdn=='') return(false);
		if(vlib_ipv4($fqdn)) return(true);
		$truelist = array();
		//$truelist[] = '[a-z0-9]+\\.(ad|ae|aero|af|ag|ai|al|am|an|ao|aq|ar|arpa|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|biz|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|com|coop|cr|cs|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|in|info|int|io|iq|ir|is|it|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|museum|mv|mw|mx|my|mz|na|name|nc|ne|net|nf|ng|ni|nl|no|np|nr|nt|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|pro|ps|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)/?$';
		$truelist[] = '^(http[s]?:/'.'/|ftp:/'.'/)?([a-z0-9]+\\.)?';
		$truelist[] = '[a-z0-9]+\\.[a-z0-9]+';
		$errlist = array('^[.-]','[@.-]$','^[_.-]$');
		$checklist = array('^[a-z0-9-]+(\\.[a-z0-9-]+)+$');
		foreach($errlist as $k=>$v) if(@eregi($v, $fqdn)) return(false);
		foreach($checklist as $k=>$v) if(!@eregi($v, $fqdn)) return(false);
		foreach($truelist as $k=>$v) if(@eregi($v, $fqdn)) return(true);
		return(true);
	}



?>